## libminc 2.3.00

=== CMakeLists.txt ===
# CMakeFiles.txt for the libminc library
#
# Andrew Janke - a.janke@gmail.com
# Vladimir S. FONOV - vladimir.fonov@gmail.com

PROJECT(LIBMINC)

SET(LIBMINC_PACKAGE_VERSION_MAJOR 2)
SET(LIBMINC_PACKAGE_VERSION_MINOR 3)
SET(LIBMINC_PACKAGE_VERSION_PATCH 00)

SET(LIBMINC_SOVERSION "4.0.0")

SET(LIBMINC_PACKAGE "libminc")
SET(LIBMINC_PACKAGE_BUGREPORT "a.janke@gmail.com")

SET(LIBMINC_PACKAGE_NAME "libminc")
SET(LIBMINC_PACKAGE_VERSION "${LIBMINC_PACKAGE_VERSION_MAJOR}.${LIBMINC_PACKAGE_VERSION_MINOR}.${LIBMINC_PACKAGE_VERSION_PATCH}")
SET(LIBMINC_PACKAGE_STRING  "${LIBMINC_PACKAGE_NAME} ${LIBMINC_PACKAGE_VERSION}")

INCLUDE(CTest)

ENABLE_TESTING()

CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

IF(MINC_TOOLKIT_BUILD)
  SET(LIBMINC_EXTERNALLY_CONFIGURED ON)
ENDIF(MINC_TOOLKIT_BUILD)

SET(LIBMINC_BUILD_V2 ON)

IF(NOT LIBMINC_EXTERNALLY_CONFIGURED)
  # Allowing User to configure parameters
  SET(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules")

  SET(CPACK_GENERATOR TGZ)
  SET(CPACK_PACKAGE_VERSION_MAJOR ${LIBMINC_PACKAGE_VERSION_MAJOR})
  SET(CPACK_PACKAGE_VERSION_MINOR ${LIBMINC_PACKAGE_VERSION_MINOR})
  SET(CPACK_PACKAGE_VERSION_PATCH ${LIBMINC_PACKAGE_VERSION_PATCH})
  SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
  SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Medical Imaging library core IO")

  OPTION(LIBMINC_BUILD_SHARED_LIBS   "Build libminc with shared libraries."        OFF)


  OPTION(LIBMINC_MINC1_SUPPORT           "Support minc1 file format, requires NETCDF" OFF)
  OPTION(LIBMINC_BUILD_EZMINC_EXAMPLES   "Build EZminc examples" OFF)

  SET (LIBMINC_EXPORTED_TARGETS "LIBMINC-targets")
  SET (LIBMINC_INSTALL_BIN_DIR bin)
  SET (LIBMINC_INSTALL_LIB_DIR lib${LIB_SUFFIX})
  SET (LIBMINC_INSTALL_INCLUDE_DIR include)
  SET (LIBMINC_INSTALL_DATA_DIR share)

  IF(LIBMINC_MINC1_SUPPORT)
    FIND_PACKAGE(NETCDF REQUIRED)
  ENDIF(LIBMINC_MINC1_SUPPORT)

  # external packages
  FIND_PACKAGE(ZLIB REQUIRED)
  FIND_PACKAGE(HDF5 REQUIRED)
  SET(HAVE_ZLIB ON)
ELSE(NOT LIBMINC_EXTERNALLY_CONFIGURED)
  #TODO: set paths for HDF5 etc
ENDIF(NOT LIBMINC_EXTERNALLY_CONFIGURED)

# Configure libminc
IF(LIBMINC_BUILD_SHARED_LIBS)
  SET(LIBRARY_TYPE SHARED)
  SET(LIBRARY_INSTALL LIBRARY)
ELSE(LIBMINC_BUILD_SHARED_LIBS)
  SET(LIBRARY_TYPE STATIC)
  SET(LIBRARY_INSTALL ARCHIVE)
ENDIF(LIBMINC_BUILD_SHARED_LIBS)

IF(CMAKE_BUILD_TYPE MATCHES Debug)
  SET(DEBUG "1")
ENDIF(CMAKE_BUILD_TYPE MATCHES Debug)

# add for building relocatable library
IF(UNIX)
  SET(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -fPIC")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
ENDIF(UNIX)

# check for prereqs
INCLUDE(CheckFunctionExists)

CHECK_FUNCTION_EXISTS(mkstemp  HAVE_MKSTEMP)
CHECK_FUNCTION_EXISTS(tmpnam   HAVE_TMPNAM)
CHECK_FUNCTION_EXISTS(tempnam  HAVE_TEMPNAM)
CHECK_FUNCTION_EXISTS(strerror HAVE_STRERROR)
CHECK_FUNCTION_EXISTS(popen    HAVE_POPEN)
CHECK_FUNCTION_EXISTS(fork     HAVE_WORKING_FORK)
CHECK_FUNCTION_EXISTS(vfork    HAVE_WORKING_VFORK)
CHECK_FUNCTION_EXISTS(fdopen   HAVE_FDOPEN)
CHECK_FUNCTION_EXISTS(strdup   HAVE_STRDUP)
CHECK_FUNCTION_EXISTS(getpwnam HAVE_GETPWNAM) 
CHECK_FUNCTION_EXISTS(select   HAVE_SELECT)
CHECK_FUNCTION_EXISTS(strerror HAVE_STRERROR) 
CHECK_FUNCTION_EXISTS(sysconf  HAVE_SYSCONF)
CHECK_FUNCTION_EXISTS(system   HAVE_SYSTEM)

CHECK_FUNCTION_EXISTS(srand48   HAVE_SRAND48)
CHECK_FUNCTION_EXISTS(drand48   HAVE_DRAND48)
CHECK_FUNCTION_EXISTS(sleep     HAVE_SLEEP)

CHECK_FUNCTION_EXISTS(gettimeofday  HAVE_GETTIMEOFDAY)

INCLUDE(CheckLibraryExists)
CHECK_LIBRARY_EXISTS(rt clock_gettime "time.h" HAVE_CLOCK_GETTIME)
IF(HAVE_CLOCK_GETTIME)
  SET(RT_LIBRARY "rt")
ENDIF(HAVE_CLOCK_GETTIME)

INCLUDE(CheckIncludeFiles)
CHECK_INCLUDE_FILES(float.h     HAVE_FLOAT_H)
CHECK_INCLUDE_FILES(sys/dir.h   HAVE_SYS_DIR_H)
CHECK_INCLUDE_FILES(sys/ndir.h  HAVE_SYS_NDIR_H)
CHECK_INCLUDE_FILES(sys/stat.h  HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILES(sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILES(sys/wait.h  HAVE_SYS_WAIT_H)
CHECK_INCLUDE_FILES(sys/time.h  HAVE_SYS_TIME_H)
CHECK_INCLUDE_FILES(values.h    HAVE_VALUES_H)
CHECK_INCLUDE_FILES(unistd.h    HAVE_UNISTD_H)
CHECK_INCLUDE_FILES(dirent.h    HAVE_DIRENT_H)
CHECK_INCLUDE_FILES(memory.h    HAVE_MEMORY_H)
CHECK_INCLUDE_FILES(stdlib.h    HAVE_STDLIB_H)
CHECK_INCLUDE_FILES(fcntl.h     HAVE_FCNTL_H)
CHECK_INCLUDE_FILES(dlfcn.h     HAVE_DLFCN_H)
CHECK_INCLUDE_FILES(vfork.h     HAVE_VFORK_H)
CHECK_INCLUDE_FILES(inttypes.h  HAVE_INTTYPES_H)
CHECK_INCLUDE_FILES(string.h    HAVE_STRING_H)
CHECK_INCLUDE_FILES(strings.h   HAVE_STRINGS_H)
CHECK_INCLUDE_FILES(pwd.h       HAVE_PWD_H)

ADD_DEFINITIONS(-DHAVE_CONFIG_H)
ADD_DEFINITIONS(-DMINC2=1)

# aliases
SET(VERSION "${LIBMINC_EXTERNAL_LIB_PREFIX}${LIBMINC_PACKAGE_VERSION}")
SET(HAVE_MINC1 ${LIBMINC_MINC1_SUPPORT})
SET(HAVE_MINC2 ON)
SET(MINC2 "1")

IF(LIBMINC_MINC1_SUPPORT)
 ADD_DEFINITIONS(-DHAVE_MINC1=1)
ENDIF(LIBMINC_MINC1_SUPPORT)

IF(LIBMINC_BUILD_EZMINC)
  set(LIBMINC_INCLUDE_DIRS_CONFIG    
    ${CMAKE_CURRENT_SOURCE_DIR}/ezminc
  )
  INCLUDE_DIRECTORIES(
    ${CMAKE_CURRENT_SOURCE_DIR}/ezminc
   )
ENDIF(LIBMINC_BUILD_EZMINC)

# config files for build
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h @ONLY)

# others
#CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/epm-header.in ${CMAKE_CURRENT_BINARY_DIR}/epm-header)

# set the master INCLUDE directories
INCLUDE_DIRECTORIES(
   ${CMAKE_CURRENT_SOURCE_DIR}
   ${CMAKE_CURRENT_BINARY_DIR}
   ${CMAKE_CURRENT_SOURCE_DIR}/libsrc2
   ${CMAKE_CURRENT_SOURCE_DIR}/libsrc
   ${CMAKE_CURRENT_SOURCE_DIR}/volume_io/Include
   ${CMAKE_CURRENT_SOURCE_DIR}/ezminc
   ${CMAKE_CURRENT_SOURCE_DIR}/nifti
   ${HDF5_INCLUDE_DIR}
   )

SET(minc_common_SRCS
   libsrc/time_stamp.c
   libsrc/read_file_names.c
   libsrc/ParseArgv.c
   libsrc/restructure.c
)

SET(minc_common_HEADERS
  libsrc/time_stamp.h
  libsrc/ParseArgv.h 
  libsrc/read_file_names.h
  libsrc/restructure.h
  volume_io/Include/volume_io.h
  nifti/nifti1.h
  nifti/nifti1_io.h
  nifti/znzlib.h
)

# some variables
SET(minc1_LIB_SRCS
   libsrc/dim_conversion.c
   libsrc/image_conversion.c
   libsrc/minc_convenience.c
   libsrc/minc_error.c
   libsrc/nd_loop.c
   libsrc/netcdf_convenience.c
   libsrc/value_conversion.c
   libsrc/voxel_loop.c
   libsrc/hdf_convenience.c
   libsrc/minc_compat.c
   libsrc/minc_simple.c
   libsrc/minc_format_convert.c
   )

SET(minc1_HEADERS
  libsrc/minc.h 
  libsrc/voxel_loop.h 
  libsrc/nd_loop.h
  libsrc/minc_compat.h
  libsrc/minc_simple.h
  libsrc/minc_format_convert.h
)

SET(minc2_LIB_SRCS
   libsrc2/convert.c
   libsrc2/datatype.c
   libsrc2/dimension.c
   libsrc2/free.c
   libsrc2/grpattr.c
   libsrc2/hyper.c
   libsrc2/label.c
   libsrc2/m2util.c
   libsrc2/record.c
   libsrc2/slice.c
   libsrc2/valid.c
   libsrc2/volprops.c
   libsrc2/volume.c
   libsrc2/minc2_error.c
   )

SET(minc2_HEADERS
  libsrc2/minc2.h
  libsrc2/minc2_defs.h 
  libsrc2/minc2_structs.h 
  libsrc2/minc2_api.h 
  libsrc2/minc2_error.h
)

# volume_io2
SET(volume_io_LIB_SRCS
   volume_io/Geometry/colour.c
   volume_io/Geometry/colour_def.c
   volume_io/Geometry/gaussian.c
   volume_io/Geometry/inverse.c
   volume_io/Geometry/newton.c
   volume_io/Geometry/points.c
   volume_io/Geometry/splines.c
   volume_io/Geometry/tensors.c
   volume_io/Geometry/transforms.c
   volume_io/MNI_formats/gen_xf_io.c
   volume_io/MNI_formats/gen_xfs.c
   volume_io/MNI_formats/grid_transforms.c
   volume_io/MNI_formats/mni_io.c
   volume_io/MNI_formats/tag_points.c
   volume_io/MNI_formats/thin_plate_spline.c
   volume_io/Prog_utils/alloc.c
   volume_io/Prog_utils/alloc_check.c
   volume_io/Prog_utils/arrays.c
   volume_io/Prog_utils/files.c
   volume_io/Prog_utils/print.c
   volume_io/Prog_utils/progress.c
   volume_io/Prog_utils/string.c
   volume_io/Prog_utils/time.c
   volume_io/Volumes/evaluate.c
   volume_io/Volumes/get_hyperslab.c
   volume_io/Volumes/input_free.c
   volume_io/Volumes/input_mnc.c
   volume_io/Volumes/input_volume.c
   volume_io/Volumes/multidim_arrays.c
   volume_io/Volumes/output_mnc.c
   volume_io/Volumes/output_volume.c
   volume_io/Volumes/set_hyperslab.c
   volume_io/Volumes/volume_cache.c
   volume_io/Volumes/volumes.c
   volume_io/Volumes/input_mnc2.c
   volume_io/Volumes/output_mnc2.c
   volume_io/Volumes/input_mgh.c
   volume_io/Volumes/input_nifti.c
   nifti/nifti1_io.c
   nifti/znzlib.c
)

SET(volume_io_HEADERS
    volume_io/Include/volume_io/alloc.h
    volume_io/Include/volume_io/arrays.h 
    volume_io/Include/volume_io/basic.h 
    volume_io/Include/volume_io/def_math.h 
    volume_io/Include/volume_io/files.h 
    volume_io/Include/volume_io/geom_structs.h 
    volume_io/Include/volume_io/geometry.h 
    volume_io/Include/volume_io/multidim.h 
    volume_io/Include/volume_io/progress.h 
    volume_io/Include/volume_io/string_funcs.h 
    volume_io/Include/volume_io/system_dependent.h 
    volume_io/Include/volume_io/transforms.h 
    volume_io/Include/volume_io/vol_io_prototypes.h 
    volume_io/Include/volume_io/volume.h 
    volume_io/Include/volume_io/volume_cache.h
)

SET(LIBMINC_LIBRARY   ${LIBMINC_EXTERNAL_LIB_PREFIX}minc2)

# a hack for APPLE
IF(LIBMINC_BUILD_SHARED_LIBS)
  SET(LIBMINC_LIBRARY_STATIC ${LIBMINC_EXTERNAL_LIB_PREFIX}minc2_static)
ELSE(LIBMINC_BUILD_SHARED_LIBS)
  SET(LIBMINC_LIBRARY_STATIC ${LIBMINC_LIBRARY})
ENDIF(LIBMINC_BUILD_SHARED_LIBS)

SET(LIBMINC_LIBRARIES ${LIBMINC_LIBRARY} ${HDF5_LIBRARY} ${ZLIB_LIBRARY} ${RT_LIBRARY})
SET(LIBMINC_STATIC_LIBRARIES ${LIBMINC_LIBRARY_STATIC} ${HDF5_LIBRARY} ${ZLIB_LIBRARY} ${RT_LIBRARY})

IF(UNIX)
  SET(LIBMINC_LIBRARIES ${LIBMINC_LIBRARIES} m dl)
  SET(LIBMINC_STATIC_LIBRARIES ${LIBMINC_STATIC_LIBRARIES} m dl)
ENDIF(UNIX)

SET(minc_LIB_SRCS ${minc2_LIB_SRCS} ${minc_common_SRCS})
SET(minc_HEADERS  ${minc2_HEADERS} ${minc_common_HEADERS})

IF(LIBMINC_MINC1_SUPPORT)
  SET(minc_HEADERS  ${minc_HEADERS}  ${minc1_HEADERS})
  SET(minc_LIB_SRCS ${minc_LIB_SRCS} ${minc1_LIB_SRCS})
ENDIF(LIBMINC_MINC1_SUPPORT)


# Keep this variable for compatibility
SET(VOLUME_IO_LIBRARY ${LIBMINC_EXTERNAL_LIB_PREFIX}minc2)

ADD_LIBRARY(${LIBMINC_LIBRARY} ${LIBRARY_TYPE} ${minc_LIB_SRCS} ${minc_HEADERS} ${volume_io_LIB_SRCS} ${volume_io_HEADERS} )
TARGET_LINK_LIBRARIES(${LIBMINC_LIBRARY} ${HDF5_LIBRARY} ${ZLIB_LIBRARY} ${RT_LIBRARY}) # 
IF(LIBMINC_MINC1_SUPPORT)
  INCLUDE_DIRECTORIES(${NETCDF_INCLUDE_DIR})
  TARGET_LINK_LIBRARIES(${LIBMINC_LIBRARY} ${NETCDF_LIBRARY})
ENDIF(LIBMINC_MINC1_SUPPORT)

EXPORT(TARGETS ${LIBMINC_LIBRARY} FILE "${LIBMINC_EXPORTED_TARGETS}.cmake")

IF(UNIX)
  TARGET_LINK_LIBRARIES(${LIBMINC_LIBRARY}   m dl )

  IF(LIBMINC_BUILD_SHARED_LIBS)
    ADD_LIBRARY(${LIBMINC_LIBRARY_STATIC} STATIC ${minc_LIB_SRCS} ${minc_HEADERS} ${volume_io_LIB_SRCS} ${volume_io_HEADERS} )
    TARGET_LINK_LIBRARIES(${LIBMINC_LIBRARY_STATIC} ${HDF5_LIBRARY} ${ZLIB_LIBRARY} ${RT_LIBRARY} m dl )
    IF(LIBMINC_MINC1_SUPPORT)
      TARGET_LINK_LIBRARIES(${LIBMINC_LIBRARY} ${NETCDF_LIBRARY})
    ENDIF(LIBMINC_MINC1_SUPPORT)
  ENDIF(LIBMINC_BUILD_SHARED_LIBS)
ENDIF(UNIX)

SET_TARGET_PROPERTIES(${LIBMINC_LIBRARY} 
 PROPERTIES 
  SOVERSION ${LIBMINC_SOVERSION})

IF(LIBMINC_MINC1_SUPPORT)
  SET(LIBMINC_LIBRARIES        ${LIBMINC_LIBRARIES} ${NETCDF_LIBRARY} )
  SET(LIBMINC_STATIC_LIBRARIES ${LIBMINC_STATIC_LIBRARIES} ${NETCDF_LIBRARY} )
ENDIF(LIBMINC_MINC1_SUPPORT)

IF( LIBMINC_INSTALL_LIB_DIR )
  INSTALL(
    TARGETS 
      ${LIBMINC_LIBRARY} 
    EXPORT
      ${LIBMINC_EXPORTED_TARGETS} 
    LIBRARY DESTINATION ${LIBMINC_INSTALL_LIB_DIR} COMPONENT libraries
    ARCHIVE DESTINATION ${LIBMINC_INSTALL_LIB_DIR} COMPONENT libraries
    RUNTIME DESTINATION ${LIBMINC_INSTALL_LIB_DIR} COMPONENT libraries
  )
ENDIF( LIBMINC_INSTALL_LIB_DIR )

IF(LIBMINC_INSTALL_INCLUDE_DIR AND NOT LIBMINC_INSTALL_NO_DEVELOPMENT)
  INSTALL(FILES   ${minc_HEADERS}      DESTINATION  ${LIBMINC_INSTALL_INCLUDE_DIR} COMPONENT headers )

=== testdir/CMakeLists.txt ===
LINK_LIBRARIES(${LIBMINC_LIBRARIES})

MACRO(minc_test cmd)
  # minc 1 version
  IF(HAVE_MINC1)
    ADD_TEST(${cmd}-1 ${CMAKE_CURRENT_SOURCE_DIR}/run_test_cmake.sh ${CMAKE_CURRENT_BINARY_DIR}/${cmd} ${CMAKE_CURRENT_SOURCE_DIR}/${cmd}.out)
  ENDIF(HAVE_MINC1)
  
  ADD_TEST(${cmd}-2 ${CMAKE_CURRENT_SOURCE_DIR}/run_test2_cmake.sh ${CMAKE_CURRENT_BINARY_DIR}/${cmd} ${CMAKE_CURRENT_SOURCE_DIR}/${cmd}.out)
  
  IF(MINC_TEST_ENVIRONMENT)
   set_tests_properties( ${cmd}-1 PROPERTIES ENVIRONMENT "${MINC_TEST_ENVIRONMENT}")
  ENDIF(MINC_TEST_ENVIRONMENT)
  
  IF(MINC_TEST_ENVIRONMENT)
   set_tests_properties( ${cmd}-2 PROPERTIES ENVIRONMENT "${MINC_TEST_ENVIRONMENT}")
  ENDIF(MINC_TEST_ENVIRONMENT)
ENDMACRO(minc_test)

MACRO(add_minc_test name cmd)

  ADD_TEST( ${name}
      ${cmd} ${ARGV2} ${ARGV3} ${ARGV4} ${ARGV5} ${ARGV6} ${ARGV7} ${ARGV8} ${ARGV9} ${ARGV10} ${ARGV11}
        ${ARGV12} ${ARGV13} ${ARGV14} ${ARGV15} ${ARGV16} ${ARGV17} ${ARGV18} ${ARGV19} ${ARGV20} ${ARGV21} ${ARGV22}
        ${ARGV23} ${ARGV24} ${ARGV25} ${ARGV26}
   )
   
   IF(MINC_TEST_ENVIRONMENT)
    set_tests_properties( ${name} PROPERTIES ENVIRONMENT "${MINC_TEST_ENVIRONMENT}")
   ENDIF(MINC_TEST_ENVIRONMENT)
   
ENDMACRO(add_minc_test)


IF(LIBMINC_MINC1_SUPPORT)

  ADD_EXECUTABLE(minc_tst minc.c)
  ADD_EXECUTABLE(icv icv.c)
  ADD_EXECUTABLE(icv_vec icv_vec.c)
  ADD_EXECUTABLE(icv_dim1 icv_dim1.c)
  ADD_EXECUTABLE(icv_dim icv_dim.c)
  ADD_EXECUTABLE(icv_fillvalue icv_fillvalue.c)
  ADD_EXECUTABLE(icv_range icv_range.c)
  ADD_EXECUTABLE(mincapi mincapi.c)
  ADD_EXECUTABLE(minc_types minc_types.c)
  ADD_EXECUTABLE(test_mconv test_mconv.c)
  ADD_EXECUTABLE(minc_long_attr minc_long_attr.c)
  ADD_EXECUTABLE(minc_conversion minc_conversion.c)

  #ADD_EXECUTABLE(test_speed test_speed.c)

  # running tests
  minc_test(minc_types)
  minc_test(icv_dim1)
  minc_test(icv_dim)
  minc_test(icv_fillvalue)
  minc_test(icv_range)

  add_minc_test(arg_parse ${CMAKE_CURRENT_SOURCE_DIR}/run_test_arg_parse_cmake.sh ${CMAKE_CURRENT_BINARY_DIR}/test_arg_parse)
  add_minc_test(icv icv)
  add_minc_test(icv_vec icv_vec)
  add_minc_test(minc minc_tst)
  add_minc_test(mincapi mincapi)
  add_minc_test(test_mconv test_mconv)
  add_minc_test(minc_long_attr_10k minc_long_attr 10000)
  add_minc_test(minc_long_attr_100k minc_long_attr 100000)
  add_minc_test(minc_long_attr_1m minc_long_attr 1000000)
  add_minc_test(minc_conversion minc_conversion)
ENDIF(LIBMINC_MINC1_SUPPORT)

ADD_EXECUTABLE(nifti_test nifti_test.c)
ADD_TEST(nifti_test-1 nifti_test)

# Volume IO tests
ADD_EXECUTABLE(test_xfm   vio_xfm_test/test-xfm.c)
TARGET_LINK_LIBRARIES(test_xfm ${VOLUME_IO_LIBRARY} ${LIBMINC_LIBRARIES})

ADD_EXECUTABLE(copy_xfm   vio_xfm_test/copy-xfm.c)
TARGET_LINK_LIBRARIES(copy_xfm ${VOLUME_IO_LIBRARY} ${LIBMINC_LIBRARIES})

ADD_EXECUTABLE(create_grid_xfm create_grid_xfm.c)
TARGET_LINK_LIBRARIES(create_grid_xfm ${VOLUME_IO_LIBRARY} ${LIBMINC_LIBRARIES})

ADD_EXECUTABLE(verify_xfm   vio_xfm_test/verify_xfm.c)
TARGET_LINK_LIBRARIES(verify_xfm ${VOLUME_IO_LIBRARY} ${LIBMINC_LIBRARIES})

#ADD_TEST(create_grid_xfm create_grid_xfm)
#ADD_TEST(test_speed test_speed)

add_minc_test(test_xfm_1 test_xfm 10000 ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/t1.xfm)
add_minc_test(test_xfm_2 test_xfm 10000 ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/t2.xfm)
add_minc_test(test_xfm_3 test_xfm 10000 ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/t3.xfm 0.9)

add_minc_test(copy_xfm copy_xfm ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/t3.xfm ${CMAKE_CURRENT_BINARY_DIR}/t3_copy.xfm)

add_minc_test(verify_xfm_1 verify_xfm
 ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/t3.xfm
 ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/random2 
 1e-6)

add_minc_test(verify_xfm_float verify_xfm
 ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/test_float.xfm
 ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/verify_xfm_table.txt
 1e-9)

add_minc_test(verify_xfm_short verify_xfm
  ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/test_short.xfm
  ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/verify_xfm_table.txt
  1e-4)
  
add_minc_test(verify_xfm_byte verify_xfm
  ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/test_byte.xfm
  ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/verify_xfm_table.txt
  1e-1) 

add_minc_test(verify_xfm_2 verify_xfm 
 ${CMAKE_CURRENT_BINARY_DIR}/t3_copy.xfm
 ${CMAKE_CURRENT_SOURCE_DIR}/vio_xfm_test/random2
 1e-3)

set_property(TEST verify_xfm_2 APPEND PROPERTY DEPENDS copy_xfm)


#common tests
ADD_EXECUTABLE(test_arg_parse test_arg_parse.c)
add_minc_test(test_arg_parse test_arg_parse)


#MINC2 tests
ADD_EXECUTABLE(minc2-convert-test minc2-convert-test.c)
ADD_EXECUTABLE(minc2-create-test-images-2 minc2-create-test-images-2.c)
ADD_EXECUTABLE(minc2-create-test-images minc2-create-test-images.c)
ADD_EXECUTABLE(minc2-datatype-test minc2-datatype-test.c)
ADD_EXECUTABLE(minc2-large-attribute minc2-large-attribute.c)
ADD_EXECUTABLE(minc2-dimension-test minc2-dimension-test.c)
ADD_EXECUTABLE(minc2-full-test minc2-full-test.c)
ADD_EXECUTABLE(minc2-grpattr-test minc2-grpattr-test.c)
ADD_EXECUTABLE(minc2-hyper-test-2 minc2-hyper-test-2.c)
ADD_EXECUTABLE(minc2-hyper-test minc2-hyper-test.c)
ADD_EXECUTABLE(minc2-label-test minc2-label-test.c)
#ADD_EXECUTABLE(minc2-m2stats minc2-m2stats.c)
ADD_EXECUTABLE(minc2-multires-test minc2-multires-test.c)
ADD_EXECUTABLE(minc2-record-test minc2-record-test.c)
ADD_EXECUTABLE(minc2-slice-test minc2-slice-test.c)
ADD_EXECUTABLE(minc2-valid-test minc2-valid-test.c)
ADD_EXECUTABLE(minc2-vector_dimension-test minc2-vector_dimension-test.c)
ADD_EXECUTABLE(minc2-volprops-test minc2-volprops-test.c)
ADD_EXECUTABLE(minc2-read-rgb minc2-read-rgb.c)
ADD_EXECUTABLE(minc2-read-metadata minc2-read-metadata.c)

add_minc_test(minc2-convert-test minc2-convert-test)
add_minc_test(minc2-create-test-images-2 minc2-create-test-images-2)
add_minc_test(minc2-create-test-images minc2-create-test-images)
add_minc_test(minc2-large-attribute-10k minc2-large-attribute 10000)
add_minc_test(minc2-large-attribute-100k minc2-large-attribute 100000)
add_minc_test(minc2-large-attribute-1m minc2-large-attribute 1000000)
add_minc_test(minc2-datatype-test minc2-datatype-test)
add_minc_test(minc2-dimension-test minc2-dimension-test)
add_minc_test(minc2-full-test minc2-full-test)
add_minc_test(minc2-grpattr-test minc2-grpattr-test)
add_minc_test(minc2-hyper-test-2 minc2-hyper-test-2)
add_minc_test(minc2-hyper-test minc2-hyper-test)
add_minc_test(minc2-label-test minc2-label-test)
#add_minc_test(minc2-m2stats minc2-m2stats)
add_minc_test(minc2-multires-test minc2-multires-test)
add_minc_test(minc2-record-test minc2-record-test)
add_minc_test(minc2-slice-test minc2-slice-test)
add_minc_test(minc2-valid-test minc2-valid-test)
add_minc_test(minc2-vector_dimension-test minc2-vector_dimension-test)
add_minc_test(minc2-volprops-test minc2-volprops-test)

=== debian/changelog ===
libminc (2.3.00-5) unstable; urgency=medium

  * Team upload
  * d/p/net..:Strip MINC flag from nccreate call, Closes: #888925

 -- Gert Wollny <gewo@debian.org>  Thu, 08 Feb 2018 14:50:07 +0100

libminc (2.3.00-4) unstable; urgency=medium

  * Moved packaging from SVN to Git
  * debhelper 10
  * Standards-Version: 4.1.1
  * Avoid test failure when tests are running in parallel mode
  * DEP3
  * hardening=+all

 -- Andreas Tille <tille@debian.org>  Thu, 30 Nov 2017 19:00:48 +0100

libminc (2.3.00-3.1) unstable; urgency=medium

  * Non-maintainer upload
  * New patch to support HDF5 1.10 (closes: #841970)

 -- Gilles Filippini <pini@debian.org>  Sun, 30 Oct 2016 18:14:22 +0100

libminc (2.3.00-3) unstable; urgency=medium

  * Wrote watch file
  * Use github issue tracker as contact
  * Use system FindHDF5 CMake module (thanks to Ghislain Antony Vaillant
    for the patch)
    Closes: #835400
  * cme fix dpkg-control

 -- Andreas Tille <tille@debian.org>  Fri, 02 Sep 2016 09:40:37 +0200

libminc (2.3.00-2) unstable; urgency=medium

  * patches/fix-endian-issues-label-data.patch: New.  Upstream fix for
    endianness problem.  Closes: #802072.

 -- Steve M. Robbins <smr@debian.org>  Sun, 15 Nov 2015 07:34:14 -0600

libminc (2.3.00-1) unstable; urgency=medium

  * New upstream.  Contains library source only.  New minc-tools source
    package will build minc-tools.
    - Fixed to build with NetCDF 4.4.  Closes: #793885.

 -- Steve M. Robbins <smr@debian.org>  Sat, 12 Sep 2015 19:20:21 -0500

minc (2.2.00-6) unstable; urgency=medium

  * Apply two patches fixing Mahem test issues.  Thanks to Martin
    Steghöfer <martin@steghoefer.eu>
    Closes: #716511, #716616
  * cme fix dpkg-control

 -- Andreas Tille <tille@debian.org>  Mon, 06 Oct 2014 09:49:50 +0200

minc (2.2.00-5) unstable; urgency=medium

  [ Gilles Filippini ]
  * rules: Support hdf5 1.8.13 new packaging layout.  Closes: #756684.

 -- Steve M. Robbins <smr@debian.org>  Sat, 02 Aug 2014 12:06:50 -0500

minc (2.2.00-4) unstable; urgency=medium

  * Apply patch provided by Alexander Ovchinnikov to build with clang
    (thanks to Alexander)
    Closes: 741744
  * cme fix dpkg-control
  * debian/copyright: DEP5

 -- Andreas Tille <tille@debian.org>  Mon, 05 May 2014 11:21:48 +0200

minc (2.2.00-3) unstable; urgency=low

  * patches/maxpathlen.patch: New.  Work around missing MAXPATHLEN on
    hurd.

 -- Steve M. Robbins <smr@debian.org>  Sat, 14 Sep 2013 00:39:06 -0500

minc (2.2.00-2) unstable; urgency=low

  * patches/pod_fix.diff: New.  Fix POD documentation to comply with
    stricter parsing of perl 5.18.  Closes: #719502.

  * rules: disable parallel build; causes tests to fail inexplicably.
  
 -- Steve M. Robbins <smr@debian.org>  Fri, 13 Sep 2013 23:22:53 -0500

minc (2.2.00-1) unstable; urgency=low

  * New upstream.
  * patches/hdfv2-fixes.patch: Remove.  Applied upstream.

  * patches/makefile.patch: New.  Fix build failure.
  * patches/acrnema-version.patch: New.  Add proper versioning to
    libacr_nema.

  * rules: Use "--with autoreconf" since new patches affect Makefile.am.

  * rules:  
  * control: SOVERSION bump to 3; new package name libminc2-3.

 -- Steve M. Robbins <smr@debian.org>  Sat, 13 Oct 2012 23:09:25 -0500

minc (2.1.10-1) unstable; urgency=low

  * New upstream.
  
  * patches/03_mincview.diff: Remove.  Script mincview rewritten to use
    Imagemagick
  
  * patches/decompress-whole-file.diff:
  * patches/read_file_names-refactor.patch: Remove.  Applied upstream.
  * rules: Remove use of dh_autoreconf.

  * patches/hdfv2-fixes.patch: New.  Ensure using HDF5 v2 API.
  
  * control: Remove dependency and build-dependency on csh.

 -- Steve M. Robbins <smr@debian.org>  Sun, 26 Feb 2012 01:37:47 -0600

minc (2.1.00-5) unstable; urgency=low

  * patches/mincaverage-pathmax.patch: Remove.
  * patches/read_file_names-refactor.patch: New.  Refactored duplicated
    PATH_MAX-using code into library.  Need to run autoreconf because
    Makefile.am changed.
  
  * rules: Fix errors and really disable tests on sparc.

 -- Steve M. Robbins <smr@debian.org>  Mon, 20 Feb 2012 15:00:32 -0600

minc (2.1.00-4) unstable; urgency=low

  * source/format: Set to 3.0 (quilt), so that patches are applied.
  
  * patches/mincaverage-pathmax.patch: New.  Work around missing PATH_MAX
    definition; fixes FTBFS on hurd.
  
  * rules: Tests are buggy, but do work on most architectures.  Disable on
    sparc.

 -- Steve M. Robbins <smr@debian.org>  Sun, 19 Feb 2012 21:58:51 -0600

minc (2.1.00-3) unstable; urgency=low

  * control: Switch to (serial) libhdf5-dev, to avoid conflict with serial
    netcdf.  Closes: #658307.
  
  * control:
  * rules: Switch from cdbs to debhelper's dh (compat level 9).

 -- Steve M. Robbins <smr@debian.org>  Sun, 19 Feb 2012 08:53:04 -0600

minc (2.1.00-2) unstable; urgency=low

  * patches/decompress-whole-file.diff: New.  Always decompress entire
    file to support compressed MINC2 files.  Closes: #585676.

 -- Steve M. Robbins <smr@debian.org>  Sun, 18 Dec 2011 20:47:03 -0600

minc (2.1.00-1) unstable; urgency=low

  * New upstream.

 -- Steve M. Robbins <smr@debian.org>  Tue, 17 Aug 2010 22:26:16 -0500

minc (2.0.18+cvs20100518-1) unstable; urgency=low

  * Pull upstream CVS, contains fixes for netcdf 4.  Closes: #577060,
    #581296.
  
  * control: replace libhdf5-*-dev (differing by architecture) by
    libhdf5-mpi-dev.

 -- Steve M. Robbins <smr@debian.org>  Tue, 18 May 2010 22:53:30 -0500

minc (2.0.18-1) unstable; urgency=low

  * New upstream version.

 -- Steve M. Robbins <smr@debian.org>  Mon, 20 Jul 2009 05:24:57 -0500

minc (2.0.17-1) unstable; urgency=low

  * New upstream version.

  * patches/04_manpages.diff:
  * debian/patches/05_parseargv.diff: Remove; applied upstream.
  
 -- Steve M. Robbins <smr@debian.org>  Tue, 20 Jan 2009 19:37:41 -0600

minc (2.0.16-4) unstable; urgency=low

  * debian/patches/05_parseargv.diff: New.  Patch from upstream to fix arg


=== debian/control ===
Source: libminc
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steve M. Robbins <smr@debian.org>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 10),
               cmake,
               libnetcdf-dev,
               libnifti-dev,
               zlib1g-dev,
               libhdf5-dev
Standards-Version: 4.1.1
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/libminc.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/libminc.git
Homepage: https://github.com/BIC-MNI/libminc

Package: libminc2-4.0.0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: MNI medical image format library
 This package contains the libraries libminc2 and libminc_io.
 .
 The Minc file format is a highly flexible medical image file format.
 Minc version 1 is built on top of the NetCDF generalized data format. 
 Minc version 2 is built on top of the HDF data format.  This library
 handles both formats.  In each case the format is
 simple, self-describing, extensible, portable and N-dimensional, with
 programming interfaces for both low-level data access and high-level
 volume manipulation. On top of the libraries is a suite of generic
 image-file manipulation tools. The format, libraries and tools are
 designed for use in a medical-imaging research environment : they are
 simple and powerful and make no attempt to provide a pretty interface
 to users.

Package: libminc-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libminc2-4.0.0 (= ${binary:Version}),
         libnetcdf-dev,
         libhdf5-dev
Conflicts: libminc0-dev
Replaces: libminc0-dev
Description: MNI medical image format development environment
 This package contains the library and headers for libminc2 and
 libminc_io.
 .
 The Minc file format is a highly flexible medical image file format.
 Minc version 1 is built on top of the NetCDF generalized data format. 
 Minc version 2 is built on top of the HDF data format.  This library
 handles both formats.  In each case the format is
 simple, self-describing, extensible, portable and N-dimensional, with
 programming interfaces for both low-level data access and high-level
 volume manipulation. On top of the libraries is a suite of generic
 image-file manipulation tools. The format, libraries and tools are
 designed for use in a medical-imaging research environment : they are
 simple and powerful and make no attempt to provide a pretty interface
 to users.

=== debian/rules ===
#! /usr/bin/make -f

export DEB_CPPFLAGS_MAINT_APPEND := -Wconversion

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

ARCH = $(shell dpkg-architecture -qDEB_TARGET_MULTIARCH)

CMAKE_FLAGS = \
	-DLIB_SUFFIX=/$(ARCH) \
	-DBUILD_TESTING:BOOL=ON \
	-DLIBMINC_BUILD_EZMINC_EXAMPLES:BOOL=ON \
	-DLIBMINC_BUILD_SHARED_LIBS:BOOL=ON \
	-DLIBMINC_MINC1_SUPPORT:BOOL=ON

%:
	dh $@

override_dh_auto_configure:
	rm -f cmake-modules/*HDF5*
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_install:
	dh_install -plibminc2-4.0.0 --autodest debian/tmp/usr/lib/*/lib*.so.*
	dh_install -plibminc-dev --autodest debian/tmp/usr/lib/*/lib*.so
	dh_install -plibminc-dev debian/tmp/usr/lib/*/*.cmake /usr/lib/$(ARCH)/cmake/LIBMINC
	dh_install -plibminc-dev --autodest debian/tmp/usr/include

override_dh_auto_test:
	dh_auto_test --no-parallel
